import { PropType, ExtractPropTypes } from 'vue';
import { PluggableList } from 'unified';
import { ElementContent, RootContent } from 'hast';
import { Components } from './utils/ast-to-vue';
import { uriTransformer } from './utils/uri-transformer';
export declare type MaybeFunction<T> = T;
declare const markdownPreview: {
    rehypePlugins: {
        type: PropType<PluggableList>;
        default: never[];
    };
    remarkPlugins: {
        type: PropType<PluggableList>;
        default: never[];
    };
    components: {
        type: PropType<Components>;
        default: {};
    };
    source: {
        type: StringConstructor;
        default: string;
    };
    sourcePos: {
        type: BooleanConstructor;
        default: boolean;
    };
    rawSourcePos: {
        type: BooleanConstructor;
        default: boolean;
    };
    includeElementIndex: {
        type: BooleanConstructor;
        default: boolean;
    };
    skipHtml: {
        type: BooleanConstructor;
        default: boolean;
    };
    linkTarget: {
        type: PropType<(href: string, children: ElementContent[], title: string | null) => string>;
    };
    transformLinkUri: {
        type: PropType<(href: string, children: RootContent[], title?: string | null | undefined) => string>;
        default: typeof uriTransformer;
    };
    transformImageUri: {
        type: PropType<(src: string, alt: string, title: string | null) => string>;
        default: typeof uriTransformer;
    };
};
declare type ExtractPublicPropTypes<T> = Omit<Partial<ExtractPropTypes<T>>, Extract<keyof T, `internal${string}`>>;
export declare type MarkdownPreviewProps = ExtractPublicPropTypes<typeof markdownPreview>;
declare const _default: import("vue").DefineComponent<{
    rehypePlugins: {
        type: PropType<PluggableList>;
        default: never[];
    };
    remarkPlugins: {
        type: PropType<PluggableList>;
        default: never[];
    };
    components: {
        type: PropType<Components>;
        default: {};
    };
    source: {
        type: StringConstructor;
        default: string;
    };
    sourcePos: {
        type: BooleanConstructor;
        default: boolean;
    };
    rawSourcePos: {
        type: BooleanConstructor;
        default: boolean;
    };
    includeElementIndex: {
        type: BooleanConstructor;
        default: boolean;
    };
    skipHtml: {
        type: BooleanConstructor;
        default: boolean;
    };
    linkTarget: {
        type: PropType<(href: string, children: ElementContent[], title: string | null) => string>;
    };
    transformLinkUri: {
        type: PropType<(href: string, children: RootContent[], title?: string | null | undefined) => string>;
        default: typeof uriTransformer;
    };
    transformImageUri: {
        type: PropType<(src: string, alt: string, title: string | null) => string>;
        default: typeof uriTransformer;
    };
}, () => JSX.Element, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, Record<string, any>, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<{
    rehypePlugins?: unknown;
    remarkPlugins?: unknown;
    components?: unknown;
    source?: unknown;
    sourcePos?: unknown;
    rawSourcePos?: unknown;
    includeElementIndex?: unknown;
    skipHtml?: unknown;
    linkTarget?: unknown;
    transformLinkUri?: unknown;
    transformImageUri?: unknown;
} & {
    rehypePlugins: PluggableList;
    remarkPlugins: PluggableList;
    components: Components;
    source: string;
    sourcePos: boolean;
    rawSourcePos: boolean;
    includeElementIndex: boolean;
    skipHtml: boolean;
    transformLinkUri: (href: string, children: RootContent[], title?: string | null | undefined) => string;
    transformImageUri: (src: string, alt: string, title: string | null) => string;
} & {
    linkTarget?: ((href: string, children: ElementContent[], title: string | null) => string) | undefined;
}>, {
    rehypePlugins: PluggableList;
    remarkPlugins: PluggableList;
    components: Components;
    source: string;
    sourcePos: boolean;
    rawSourcePos: boolean;
    includeElementIndex: boolean;
    skipHtml: boolean;
    transformLinkUri: (href: string, children: RootContent[], title?: string | null | undefined) => string;
    transformImageUri: (src: string, alt: string, title: string | null) => string;
}>;
export default _default;
